import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

class Artikel
{
	private String name;
	private String nummer;

	public Artikel(String name, String nummer)
	{
		this.name   = name;
		this.nummer = nummer;
	}	
	public void ausgabe()
	{
		System.out.println("Artikel " + name + " mit Nummer " + nummer);
	}
}
class ZuAdaptierendeKlasse
{
	public ArrayList<String []> leseDatei(String file)
	{
		ArrayList<String []> artikel = new ArrayList<String[]>();
		try 
		{
			File datei = new File(file);		
			Scanner in = new Scanner(datei);
			while (in.hasNextLine())
			{
				String string = in.nextLine();
				String name[] = string.split(";");
				if (name.length >= 2)
					artikel.add(new String[] {name[0], name[1]});		
			}
			in.close();	
		}
		catch (FileNotFoundException e) 
		{
			System.out.println("Datei ist nicht vorhanden"); 
		}
		return artikel;
	}
}
class Adapter implements IZiel
{
	private String file;
	
	public Adapter(String file)
	{
		this.file = file;
	}
	public ArrayList<Artikel> leseArtikel()
	{
		ZuAdaptierendeKlasse zA      = new ZuAdaptierendeKlasse();
		ArrayList<String []> artikel = zA.leseDatei(file);
	
		ArrayList<Artikel> artikelVector = new ArrayList<Artikel>();
		for(String name[] : artikel)
			artikelVector.add(new Artikel(name[0], name[1]));
	
		return artikelVector;
	}
}
public class TestAdapter
{
	public static void main (String[] args) throws FileNotFoundException
	{
		IZiel adapter              = new Adapter("Artikel.csv");
		ArrayList<Artikel> artikel = adapter.leseArtikel();
		for (Artikel a : artikel)
			a.ausgabe();
	}
}




