
interface IProdukt
{
	public double getPreis();
	public void getMerkmale();
}

abstract class Ausstattung implements IProdukt
{
	protected IProdukt produkt;
	
	public Ausstattung (IProdukt produkt)
	{
		this.produkt = produkt;
	}
}

class Produkt1 implements IProdukt
{
	public double getPreis()
	{
		return 320;
	}
	public void getMerkmale()
	{
		System.out.print("Produkt 1");
	}
}

class Produkt2 implements IProdukt
{
	public double getPreis()
	{
		return 150;
	}
	public void getMerkmale()
	{
		System.out.print("Produkt 2");
	}
}

class Ausstattung1 extends Ausstattung
{
	public Ausstattung1(IProdukt produkt)
	{
		super(produkt);
	}
	
	public double getPreis()      
	{
		return produkt.getPreis() + 15.50;
	}
	public void getMerkmale() 	
	{
		produkt.getMerkmale();
		System.out.print(" mit Ausstattung1");
	}
}
	
class Ausstattung2 extends Ausstattung
{
	public Ausstattung2(IProdukt produkt)
	{
		super(produkt);
	}
	
	public double getPreis()      
	{
		return produkt.getPreis() + 50;
	}
	public void getMerkmale()     
	{
		produkt.getMerkmale();
		System.out.print(" mit Ausstattung2");
	}
}

public class TestDokorierer 
{
	public static void main(String[] args)
	{ 
		IProdukt produkt = new Produkt1();
	
		produkt = new Ausstattung1(produkt);
		produkt.getMerkmale();
		System.out.println("; Preis  " + produkt.getPreis() + " Euro");
		
		produkt = new Ausstattung2(produkt);
		produkt.getMerkmale();
		System.out.println("; Preis  " + produkt.getPreis() + " Euro");
		
		produkt = new Ausstattung1(new Produkt2());
		produkt.getMerkmale();
		System.out.println("; Preis " + produkt.getPreis() + " Euro");
	}
}
