
interface IStrategie
{
	public void algorithmus(String name, String vorname, int jahr);
}

class Person
{
	private IStrategie strategie = null;
	private String name, vorname;
	private int jahr;
	
	public Person(String name, String vorname, int jahr)
	{
		this.name    = name;
		this.vorname = vorname;
		this.jahr    = jahr;
	}
	public void setzeStrategie(IStrategie strategie)
	{
		this.strategie = strategie;
	}
	public void anwendenStrategie()
	{
		strategie.algorithmus(name, vorname, jahr);
	}
}

class KonkreteStrategie1 implements IStrategie
{
	public void algorithmus(String name, String vorname, int jahr)
	{
		System.out.println(vorname + " " + name + " (geb. " + jahr + ")");
	}
}

class KonkreteStrategie2 implements IStrategie
{
	public void algorithmus(String name, String vorname, int jahr)
	{
		System.out.println(name + ", " + vorname + ", Jg. " + jahr);
	}
}


public class TestStrategie 
{
	public static void main (String[] args)
	{
		Person person = new Person("Schmidt", "Anton", 1965);
		person.setzeStrategie(new KonkreteStrategie1());
		person.anwendenStrategie();
		person.setzeStrategie(new KonkreteStrategie2());
		person.anwendenStrategie();
	}
}
