abstract class Produkt
{
	protected int prodnr;	 // Produktnummer
	protected String name;   // Produktname
	protected int preis;     // Produktpreis

    public Produkt(){}
    
    public abstract double getPreis();
}
 
class Produkt_A extends Produkt
{
	protected double preisMaterial;   // Preis des Materials
	protected double preisStunde;     // Preis pro Stunde
	protected double anzahlStunden;   // Anzahl der Stunden
	protected final double mwst = 1.19;
	
	public Produkt_A(double preisMaterial, double preisStunde, double anzahlStunden)
	{
		this.preisMaterial = preisMaterial;
		this.preisStunde   = preisStunde;
		this.anzahlStunden = anzahlStunden;
	}

	public double getPreis()
	{
		return mwst * (preisMaterial + preisStunde * anzahlStunden);
    }
}
 
class Produkt_B extends Produkt
{
	protected double preisMaterial;     // Preis des Materials
	protected double preisArbeit;       // Preis der Arbeit
	protected final double mwst = 1.07;

	public Produkt_B(double preisMaterial, double preisArbeit)
	{
		this.preisMaterial = preisMaterial;
		this.preisArbeit   = preisArbeit;
	}

	public double getPreis()
	{
		return mwst * (preisMaterial + preisArbeit);
    }
}
 
public class Preisberechnung
{
	 public static void main(String[] args)
	 {
		 Produkt prod[] = new Produkt[3];
		 prod[0] = new Produkt_A(100.34, 39.00, 3);
		 prod[1] = new Produkt_B(59.99, 50);
		 prod[2] = new Produkt_A(59.99, 50.00, 4.6);
		 
		 double summe = 0.0;
		 for(Produkt p : prod)
			 summe = summe + p.getPreis();
		 System.out.printf("Preis aller Produkte = %1.2f Euro", summe);
	 }
}
 




 
 