import java.util.NoSuchElementException;

public class BinBaum 
{
	private Knoten wurzel;
	
	public BinBaum() 
	{
		wurzel = null;
	}	
	public BinBaum(Object obj) 
	{
		wurzel = new Knoten(null, obj, null);
	}
	public BinBaum(BinBaum links, Object obj, BinBaum rechts) 
	{
		wurzel = new Knoten(links.wurzel, obj, rechts.wurzel);
	}
	
	public Object getRoot() 
	{
		if (wurzel == null) 
			throw new NoSuchElementException("Ein leerer Baum hat keine Wurzel.");
		return wurzel.getObject();
	}
	public BinBaum getLeft() 
	{
		if (wurzel == null) 
			throw new NoSuchElementException("Ein leerer Baum hat keinen linken Teilbaum.");
		BinBaum l = new BinBaum();
		l.wurzel = wurzel.getRight();
		return l;
	}
	public BinBaum getRight() 
	{
		if (wurzel == null) 
			throw new NoSuchElementException("Ein leerer Baum hat keinen rechten Teilbaum.");
		BinBaum r = new BinBaum();
		r.wurzel = wurzel.getLeft();
		return r;
	}
	public boolean isEmpty() 
	{
		return wurzel == null;
	}
	public int size() 
	{
		if (wurzel == null) 
			return 0;
		else 
			return wurzel.size();	
	}
	
	public static void main(String[] args) 
	{
		BinBaum k1 = new BinBaum(8);
		BinBaum k2 = new BinBaum(9);
		BinBaum k3 = new BinBaum(k1, 4, k2);
		BinBaum k4 = new BinBaum(5);
		BinBaum k5 = new BinBaum(6);
		BinBaum k6 = new BinBaum(7);
		BinBaum k7 = new BinBaum(k3, 2, k4);
		BinBaum k8 = new BinBaum(k5, 3, k6);
		BinBaum k9 = new BinBaum(k7, 1, k8); 
		
		System.out.printf("Anzahl der Knoten im Baum: %d\n", k9.size());
		System.out.printf("Anzahl der Knoten im Teilbaum k7: %d\n", k7.size());
		System.out.printf("Name des Wurzelknoten vom Teilbaum k7: %d\n", k7.getRoot());
	}
}


class Knoten 
{
	private Knoten links, rechts;
	private Object obj;
	public Knoten(Knoten links, Object obj, Knoten rechts) 
	{
		this.links  = links;
		this.obj    = obj;
		this.rechts = rechts;
	}	
	public Object getObject() 
	{
		return obj;
	}
	public Knoten getLeft()
	{	
		return links;
	}
	public Knoten getRight() 
	{
		return rechts;
	}
	public int size() 
	{
		int sizeLinks  = 0;
		int sizeRechts = 0;
		if (links != null) 
			sizeLinks = links.size();
		if (rechts != null) 
			sizeRechts = rechts.size();
		
		return 1 + sizeLinks + sizeRechts;
	}
}