
import java.util.BitSet;
import java.util.Vector;

public class Rucksackproblem extends GenetischerAlgorithmus
{  
	private double gewinn[];  // Gewinn der Objekte
	private double gewicht[]; // Gewicht der Objekte
	private double G;         // gewichtsgrenze
	private int n;		      // Anzahl der Knoten
	
	public Rucksackproblem(double gewinn[], double gewicht[], double G)
	{
		this.gewinn  = gewinn;
		this.gewicht = gewicht;
		this.G       = G;
		this.n       = gewinn.length;
		this.setAnzahlLoesungselemente(n);
	}
	
	protected Rucksack berechneStartLoesung()
	{
		BitSet x = new BitSet();
		for(int i=0; i<n; i++)
			if(Math.random() < 0.5)
				x.set(i);
		return new Rucksack(x, n);
	}

	protected double berechneFitnessfunktion(Loesung lsg) 
	{
		BitSet x  = ((Rucksack) lsg).getRucksack();
		double w = 0;
		double g = 0;
		for(int i=0; i<n; i++) 
		{
			if (x.get(i))
			{
				w = w + gewinn[i];
				g = g + gewicht[i];
			}
		}
		if (g <= G)
			return -w;
		else
			return -(w - (g - G));
	}
	
	protected Loesung mutiereLoesung(Loesung lsg, double p) 
	{
		BitSet x  = ((Rucksack) lsg).getRucksack();
		for(int i=0; i<n; i++) 
			if (Math.random() < p)
				x.flip(i);	
		return new Rucksack(x, n);
	}

	protected Loesung kombiniereLoesung(Loesung lsg1, Loesung lsg2, int k) 
	{
		BitSet vater  = ((Rucksack) lsg1).getRucksack();
		BitSet mutter = ((Rucksack) lsg2).getRucksack();
		for(int i=k; i<n; i++) 
		{
			if(vater.get(i)!= mutter.get(i))
				vater.flip(i);;
		}
		return new Rucksack(vater, n);
	}
	
	protected Rucksack kopiereLoesung(Loesung lsg) 
	{
		BitSet x     = ((Rucksack) lsg).getRucksack();
		BitSet x_neu = (BitSet) x.clone();
		return new Rucksack(x_neu, n);
	}
}