import java.util.BitSet;
import java.util.Vector;

public class Rucksackproblem extends SimulatedAnnealing 
{  
	private double gewinn[];  // Gewinn der Objekte
	private double gewicht[]; // Gewicht der Objekte
	private double G;         // gewichtsgrenze
	private int n;		      // Anzahl der Knoten
	
	public Rucksackproblem(double gewinn[], double gewicht[], double G)
	{
		this.gewinn  = gewinn;
		this.gewicht = gewicht;
		this.G       = G;
		this.n       = gewinn.length;
	}
	
	protected Rucksack berechneStartLoesung()
	{
		BitSet x = new BitSet();
		double gew = 0;
		for(int i=0; i<n; i++)
		{
			if((gew = gew + gewicht[i]) <= G)
				x.set(i);
			else
				break;
		}
		return new Rucksack(x, n);
	}

	protected double berechneZielfunktion(Loesung lsg) 
	{
		BitSet x  = ((Rucksack) lsg).getRucksack();
		double w = 0;
		for(int i=0; i<n; i++) 
			if (x.get(i))
				w = w + gewinn[i];	
		return -w;
	}

	protected Rucksack kopiereLoesung(Loesung lsg) 
	{
		BitSet x     = ((Rucksack) lsg).getRucksack();
		BitSet x_neu = (BitSet) x.clone();
		return new Rucksack(x_neu, n);
	}

	// Austausch zweier Gegenstnde
	protected Rucksack aendereLoesung(Loesung lsg) 
	{
		Rucksack r = (Rucksack) lsg;
		BitSet  x  = r.getRucksack();
		// Entfernung eines Gegenstandes
		while(true)
		{
			int idx = (int)(n * Math.random());
			if (x.get(idx))
			{
				x.clear(idx);
				break;
			}
		}

		// Hinzufuegen von Gegenstaenden
		Vector<Integer> frei = ((Rucksack) lsg).getRucksackFrei();
		int m      = frei.size();
		int perm[] = Zufall.randperm(m, m);
		for(int i=0; i<m; i++)
		{
			int h = frei.elementAt(perm[i]);
			if(r.getGewichtRucksack(gewicht) + gewicht[h] < G)
				x.set(h);
		}
		return new Rucksack(x, n);
	}
}