
public class Rundreiseproblem extends SimulatedAnnealing 
{  
	private double abstaende[][]; // Abstandsmatrix
	private int position[][];     // Knotenposition
	private int n;				  // Anzahl der Knoten
	
	public Rundreiseproblem(double A[][], int pos[][])
	{
		abstaende = A;
		position  = pos; 
		n         = A.length;
	}
	
	public int[][] getPosition()
	{
		return position;
	}
	
	protected Rundreise berechneStartLoesung()
	{
		int x[] = new int[n+1];
		for (int i=0; i<n; i++)
			x[i] = i;
		x[n] = 0;
		return new Rundreise(x);
	}

	protected double berechneZielfunktion(Loesung lsg) 
	{
		int x[]  = ((Rundreise) lsg).getRundreise();
		double w = 0;
		for(int i=0; i<n; i++) 
			w = w + abstaende[x[i]][x[i+1]];	
		return w;
	}

	protected Rundreise kopiereLoesung(Loesung lsg) 
	{
		int x[] = ((Rundreise) lsg).getRundreise();
		return new Rundreise(x);
	}

	protected Rundreise aendereLoesung(Loesung lsg) 
	{
		int x[]     = ((Rundreise) lsg).getRundreise();
		int x_neu[] = x.clone();
		
		// v = randperm(n, 2);
		int v1=-1, v2=-1;
		while (v1 == v2)
		{
			v1 = (int) ((n)*Math.random());
			v2 = (int) ((n)*Math.random());
		}
				
		for(int i=0; i<n+1; i++)
		{
			if (x[i] == v1)
				x_neu[i] = v2;
			else if (x[i] == v2)
				x_neu[i] = v1;
		}   
		
		return new Rundreise(x_neu);
	}
}
