import java.util.Vector;


public class DS_Test 
{
	public static void main(String args[])
	{
		
		int par = 8;
		
		switch (par)
		{
			case 1: // -------------- Krzeste Wege (Dijkstra-Algo) ----------------------
				double Mat[][] = {{0, 4,  3, 0, 0}, // Beispiel OR-Skript
				                  {4, 0,  5, 3, 8}, 
				      		      {3, 5,  0, 2, 10}, 
				      		      {0, 3,  2, 0, 4}, 
				      		      {0, 8, 10, 4, 0}};		
				
				Graph A1 = new Graph(Mat, true);
				System.out.printf(" Anzahl der Knoten: %d\n", A1.getKnotenanzahl());
				System.out.printf(" Anzahl der Kanten: %d\n", A1.getKantenanzahl());
				
				int v = 1;
				Vector<Integer> NG = A1.getNachbarn(v);
				System.out.printf(" Nachbarn von Knoten: ");
				for(int i=0; i<NG.size(); i++)
					System.out.printf("%d ", NG.elementAt(i));
					
				double d1[] = {15, 17, 13, 12, 14};
				System.out.printf("\n Minimum Index: %d\n", NG.elementAt(A1.getMinimum(NG, d1)));
		
				int vV[] = new int[A1.getKnotenanzahl()];
				double d[] = A1.Dijkstra(0, vV);
				for(int i=0; i<d.length; i++)
					System.out.printf(" %f ", d[i]);

				System.out.println();
				Vector v_pfad = A1.berechnePfad(vV, 0);
				for(int i=v_pfad.size()-1; i>=0; i--)
					System.out.printf(" %d ", v_pfad.elementAt(i));
				System.out.printf("\n");

				break;
							
			case 2: // ----------------- A*-Algo --------------------------
		
				Graph A2 = new Graph(10, false); // bungsaufgabe 
				A2.addKante(0,1,75);	
				A2.addKante(0,2,140);
				A2.addKante(0,3,118);
				A2.addKante(2,4,99);
				A2.addKante(2,5,80);
				A2.addKante(3,6,280);
				A2.addKante(4,8,211);
				A2.addKante(5,6,146);
				A2.addKante(5,7,97);
				A2.addKante(6,7,138);
				A2.addKante(7,8,101);
				A2.addKante(1,9,71);
				A2.addKante(2,9, 151);
				//A2.ausgabeMatrix();
				
				// Luftlinie fr A* Algo
				double ll[] = {366,374,253,329,176,193,160,100,0,380};
				A2.Astern(0,8,ll);
				
				break;

			case 3: // ----------------- DFS/BFS --------------------------
				
				Graph A3 = new Graph(11, true); // Beispiel Vorlesung
				A3.addKante(0,1,1);
				A3.addKante(0,2,1);
				A3.addKante(0,3,1);
				A3.addKante(1,4,1);
				A3.addKante(4,9,1);
				A3.addKante(2,5,1);
				A3.addKante(2,6,1);
				A3.addKante(2,7,1);
				A3.addKante(6,10,1);
				A3.addKante(3,8,1);
				
				System.out.printf("Breitensuche:\n");
				int zahlB[] = A3.breitensuche(0);
				for(int i=0; i<A3.getKnotenanzahl(); i++)
					System.out.printf(" Knoten %d mit Nr. %d\n", i, zahlB[i]);

				System.out.printf("Tiefensuche:\n");
				int zahlT[] = new int[A3.getKnotenanzahl() + 1]; // Letztes Element laufende Nummer
				int s = 0;
				zahlT[s] = 1;
				zahlT[A3.getKnotenanzahl()] = 2;
				A3.tiefensuche(s, zahlT);
				for(int i=0; i<A3.getKnotenanzahl(); i++)
					System.out.printf(" Knoten %d mit Nr. %d\n", i, zahlT[i]);

				break;

			case 4: // -------------- Minimal aufspannnender Baum (Prim-Algo) ----------------------
				double matC[][] = {{0, 2, 10, 7, 8, 5},  
				                   {2, 0,  0, 0, 4, 0}, 
				      		       {10, 0, 0, 0, 0, 8}, 
				      		       {7, 0, 0, 0, 3, 9}, 
				      		       {8, 4, 0, 3, 0, 7},
				      		       {5, 0, 8, 9, 7, 0}};		
				
				Graph A4 = new Graph(matC, false);
				System.out.println("Eingabe: ");
				A4.ausgabeMatrix();
				System.out.printf(" Anzahl der Knoten: %d\n", A4.getKnotenanzahl());
				System.out.printf(" Anzahl der Kanten: %d\n", A4.getKantenanzahl());
				System.out.println("Ausgabe: ");
				Graph A4_MST = A4.berechneAufspannendenBaum();
				A4_MST.ausgabeMatrix();
				System.out.printf(" Anzahl der Knoten: %d\n", A4_MST.getKnotenanzahl());
				System.out.printf(" Anzahl der Kanten: %d\n", A4_MST.getKantenanzahl());

				break;

			case 5: // -------------- Maximaler Fluss (Ford-Fulkerson-Algo) ----------------------
				double C[][] =    {{0, 14, 15, 0, 0, 0}, 
								   {0, 0, 8, 12, 0, 0}, 
								   {0, 4, 0, 0, 14, 0}, 
								   {0, 0, 10, 0, 0, 21}, 
								   {0, 0, 0, 7, 0, 6}, 
								   {0, 0, 0, 0, 0, 0}};
							
				Graph A5 = new Graph(C, true);
				System.out.println("Eingabe: ");
				A5.ausgabeMatrix();
				System.out.printf(" Anzahl der Knoten: %d\n", A5.getKnotenanzahl());
				System.out.printf(" Anzahl der Kanten: %d\n", A5.getKantenanzahl());
				System.out.println("Ausgabe: ");
				System.out.println("\n Maximaler Fluss = " + A5.berechneMaxFluss(0, 5));
				
				break;

			case 6: // -------------- Eulerkreis ----------------------
				double adj[][] =  {{0, 1, 1, 0, 0}, 
								   {1, 0, 1, 1, 1}, 
								   {1, 1, 0, 0, 0}, 
								   {0, 1, 0, 0, 1}, 
								   {0, 1, 0, 1, 0}};
							
				Graph A6 = new Graph(adj, false);
				System.out.println("Eingabe: ");
				A6.ausgabeMatrix();
				System.out.printf(" Anzahl der Knoten: %d\n", A6.getKnotenanzahl());
				System.out.printf(" Anzahl der Kanten: %d\n", A6.getKantenanzahl());
				System.out.println("Ausgabe: ");
				Vector p = A6.berechneEulerTour();
				for(int i=0; i<p.size(); i++)
					System.out.printf(" %d ", p.elementAt(i));
				
				break;
				
			case 7: // -------------- Unabhngige Knotenmenge ----------------------
			   double a7[][] ={{0, 1, 1, 1, 0, 0, 0, 0}, 
							   {1, 0, 1, 0, 0, 0, 0, 0},
							   {1, 1, 0, 0, 0, 0, 0, 0},
							   {1, 0, 0, 0, 1, 1, 1, 1}, 
							   {0, 0, 0, 1, 0, 0, 0, 0},
							   {0, 0, 0, 1, 0, 0, 0, 0}, 
							   {0, 0, 0, 1, 0, 0, 0, 0},
							   {0, 0, 0, 1, 0, 0, 0, 0}};
			   
			   /*double a7[][] ={{0, 0, 0, 0, 0, 0, 0, 0}, 
							   {0, 0, 1, 0, 0, 0, 0, 0},
							   {0, 1, 0, 1, 0, 0, 0, 0},
							   {0, 0, 1, 0, 0, 0, 0, 0}, 
							   {0, 0, 0, 0, 0, 1, 1, 0},
							   {0, 0, 0, 0, 1, 0, 1, 0}, 
							   {0, 0, 0, 0, 1, 1, 0, 0},
							   {0, 0, 0, 0, 0, 0, 0, 0}};*/
				/*Graph A8 = new Graph(a8, false);
				Vector<Graph> c = A8.bestimmeKomponenten();
				for(int i=0; i<c.size(); i++)
					c.elementAt(i).ausgabeMatrix();
				*/
								
				Graph A7 = new Graph(a7, false);
				System.out.println("Unabhngigkeitszahl = " + A7.berechneUnabhngigkeitszahl());	
				
				break;
				
			case 8: // -------------- Unabhngige Knotenmenge ----------------------
				   
				double a8[][] ={{0, 1, 1, 1, 0, 0, 0}, 
								{1, 0, 0, 1, 1, 0, 0},
							    {1, 0, 0, 1, 0, 1, 0},
							    {1, 1, 1, 0, 1, 0, 0}, 
							    {0, 1, 0, 1, 0, 0, 1},
							    {0, 0, 1, 0, 0, 0, 1}, 
							    {0, 0, 0, 0, 1, 1, 0}};
									
				Graph A8 = new Graph(a8, false);
				int f[] = new int[a8.length];
				System.out.println("Faerbung moeglich : " + A8.bestimmeFaerbung(0, f, 3));
				LinAlgebra.ausgabe(f);	
				
				break;				
		}
	}
}
