
public class Zahlendarstellung
{
	public static void main(String[] args)
	{
		// ---------------------- Eingabe ----------------------
		// --- 1. Anfangszustand
		int z0 = 0;

		// --- 2. bergangsfunktion: {0..9, +-, ., E}, -1 ... kein bergang
		int delta[][] = { 
			{ 2,  1,  -1, -1},       //Zustand 0
			{ 2, -1,  -1, -1},       //Zustand 1
			{ 2, -1,   3,  5},       //Zustand 2
			{ 4, -1,  -1, -1},       //Zustand 3
			{ 4, -1,  -1,  5},       //Zustand 4
			{-1,  6,  -1, -1},       //Zustand 5
			{ 7, -1,  -1, -1},       //Zustand 6
			{ 7, -1,  -1, -1},       //Zustand 7			
		};

		// --- 3. Endzustand
		int F[] = {2, 4, 7};
		
		// --- 4. Wort
		String w = "234.98";
		
		// ---------------------------------------------------------------
		// --- 1. Definition eines Automaten
		Automat a = new Automat(delta, z0, F);
		
		// --- 2. Bearbeitung des Wortproblems
		if (a.wortproblem(string2Int(w)))
			System.out.printf("Automat akzeptiert das Wort.");	
		else
			System.out.printf("Automat akzeptiert das Wort nicht.");				
	}
	
	// Gegeben: Codierung der bergangsfunktion
	public static int[] string2Int(String w)
	{
		int w_idx[] = new int[w.length()];
		for(int i=0; i<w.length(); i++)
		{
			switch(w.charAt(i))
			{
				case '0': case '1': case '2': case '3': case '4': case '5': 
			    case '6': case '7': case '8': case '9': w_idx[i] = 0; break;  
				
			    case '+': case '-': w_idx[i] = 1; break;
				case '.': 			w_idx[i] = 2; break;
				case 'E': 			w_idx[i] = 3; break;
				default: 			w_idx[i] = -1;
			}
		}
		return w_idx;
	}
}