
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class Bild 
{
    private BufferedImage bild;                
    private JFrame frame;                       
    private int breite, hoehe;   
    private String name;

    public Bild(int breite, int hoehe) 
    {
        bild = new BufferedImage(breite, hoehe, BufferedImage.TYPE_INT_RGB);
    }

    public Bild(String name) 
    {
        try 
        {
            File file = new File(name);
            bild      = ImageIO.read(file);
            this.name = name;
            breite    = bild.getWidth(null);
            hoehe     = bild.getHeight(null);
        }
        catch(IOException e) 
        {
            throw new RuntimeException("Datei " + name + " kann nicht geoeffnet werden.");
        }
    }
    
    public int getHoehe() 
    {
        return hoehe;
    }
    public int getBreite() 
    {
        return breite;
    }

    public void anzeigen() 
    {
        if (frame == null) 
        {
            frame = new JFrame();
            frame.setContentPane(new JLabel(new ImageIcon(bild)));
            frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
            frame.setTitle(name);
            frame.pack();
            frame.setVisible(true);
        }
        frame.repaint();
    }

    public Color get(int spalte, int zeile) 
    {
        return new Color(bild.getRGB(spalte, zeile));
    }
    public void set(int spalte, int zeile, Color color) 
    {
        bild.setRGB(spalte, zeile, color.getRGB());
    }
    
    public void speichern(String name) 
    {
        String endung = name.substring(name.lastIndexOf('.') + 1);
        try 
        {
            ImageIO.write(bild, endung, new File(name));
        }
        catch (IOException e) 
        {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) 
    {
        Bild bild = new Bild("MR.jpg");
        bild.anzeigen();
    }
}


