import java.awt.Color;

public class Kanten implements IFilter
{
	private String name; 
	private int groesse = 3;
	private double filter_x[][];
	private double filter_y[][];
			
	public Kanten(String name)
	{
		this.name     = name;
		this.filter_x = this.setFilter(name + "x");
		this.filter_y = this.setFilter(name + "y");
	}
	
	// Auswahl des Filtertyps
	public double[][] setFilter(String fname)
	{
		switch (fname)
		{
			case "Diffx":
				double filter1[][] = {{0,0,0},{-1,1,0},{0,0,0}};
				return filter1;
			case "Diffy":
				double filter2[][] = {{0,-1,0},{0,1,0},{0,0,0}};
				return filter2;
			case "SymDiffx":
				double filter3[][] = {{0,0,0},{-1.0/2,0,1.0/2},{0,0,0}};
				return filter3;
			case "SymDiffy":
				double filter4[][] = {{0,-1.0/2,0},{0,0,0},{0,1.0/2,0}};
				return filter4;
			case "Sobelx":
				double filter5[][] = {{-1.0/8,0,1.0/8},{-2.0/8,0,2.0/8},{-1.0/8,0,1.0/8}};
				return filter5;
			case "Sobely":
				double filter6[][] = {{-1.0/8,-2.0/8,1.0/8},{0,0,0},{1.0/8,2.0/8,1.0/8}};
				return filter6;	
			default:
				System.out.printf("Filter nicht vorhanden!\n");
				return null;
		}	
	}

	public int conv2(int f[][], int x, int y, double filter[][])
	{
		int m = (groesse - 1)/2;	
		double farbe = 0;
		for (int i=-m; i <= m; i++) 
			for (int j=-m; j <= m; j++) 
				farbe = farbe + f[x+i][y+j] * filter[m+i][m+j];
		return (int) farbe;
	}
	
	public static int[][] color2int(BildFilter bild)
	{
		int breite  = bild.getBreite()/2;
		int hoehe   = bild.getHoehe();		
		int bildMat[][] = new int[breite][hoehe];
		for (int x = 0; x < breite; x++) 
			for (int y = 0; y < hoehe; y++) 
				bildMat[x][y] = bild.get(x, y).getRed();  
		return bildMat;
	}
	
	public void filterAlgorithmus(BildFilter bild) 
	{
		int f[][]   = color2int(bild);
		int breite  = bild.getBreite()/2;
		int hoehe   = bild.getHoehe();
		int m       = (groesse - 1)/2;

		int wert = 0; int max = 0;
		for (int x = breite+1 + m; x < 2*breite-m; x++)  
		{
			for (int y = m; y < hoehe-m; y++) 
			{
				double fx = conv2(f, x-breite, y, filter_x);
				double fy = conv2(f, x-breite, y, filter_y);
				//wert      = 255 - (int) Math.sqrt(fx*fx + fy*fy);
				wert      = (int) Math.sqrt(fx*fx + fy*fy);
				bild.set(x, y, new Color(wert, wert, wert));		
				
				if (wert > max) // Maximaler Grauwert 
					max = wert;
			}
		}
		
		// Skalierung der Farbwerte 
		for (int x = breite+1 + m; x < 2*breite-m; x++) // Rand auslassen
		{
			for (int y = m; y < hoehe-m; y++) 
			{
				Color farbe = bild.get(x, y);
				int fwert   = 255*farbe.getRed()/max;   // Grauwert
				Color c     = new Color(fwert,fwert,fwert);
				bild.set(x, y, c);
			}
		}

		// Skalierung der Farbwerte 
		for (int x = breite+1 + m; x < 2*breite-m; x++) // Rand auslassen
		{
			for (int y = m; y < hoehe-m; y++) 
			{
				Color farbe = bild.get(x, y);
				int fwert   = farbe.getRed(); 
				if (fwert > 20)
					bild.set(x, y, new Color(0,0,0));				
				else
					bild.set(x, y, new Color(255,255,255));
			}
		}
	}
}
